# KDTree implementations comparison

This compares several implementations of `KDTree` against one made using Cython+.

## Reproducing benchmarks on GNU/Linux

> ⚠ Currently this project `make` targets have been written for GNU/Linux as it makes
> uses of `taskset(1)` to set CPU affinity. You define CPU affinity under others OS
> easily using the `OMP_NUM_THREADS` environment variable.

You need to have [`conda`](https://docs.conda.io/en/latest/) installed on your system.

Then simply clone the repository and `make`:

```bash
git clone https://lab.nexedi.com/jjerphan/kdtree.git
cd kdtree
make
```

PDF reports will be written in a subfolder in `results` whose names match: `<commit-hash>_analysis`

## Running tests

```python
conda activate kdtree
pip install pytest
pytest tests
```
